#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<int>> g;
vector<int> num;
vector<bool> used;

void dfs(int v, int cur) {
    num[v] = max(num[v], cur);
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, num[v] - 1);
            num[v] = max(num[v], num[to] - 1);
        }
    }
}

void dfs1(int v, int cur) {
    num[v] = max(num[v], cur);
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs1(to, num[v] - 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    used.resize(n, false);
    num.resize(n, -1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a>> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < k; i ++) {
        int x;
        cin >> x;
        x--;
        cin >> num[x];
    }
    dfs(0, num[0]);
    used.clear();
    used.resize(n, false);
    dfs1(0, num[0]);
    set<int> ans;
    for (int i = 0; i < n; i++) {
        if (num[i] >= 0) {
            ans.insert(i + 1);
        }
    }
    vector<int> num1 = num;
    cout << int(ans.size()) << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
    return 0;
}
